package cours8.handwrittenSQL.test;


import org.hibernate.Session;
import org.hibernate.Transaction;

import test.TestCase;
import cours8.handwrittenSQL.model.Coach;
import cours8.handwrittenSQL.model.Game;
import cours8.handwrittenSQL.model.Player;
import cours8.handwrittenSQL.model.Team;

/**
 * No actual test, but only test data initialization.
 *
 * @author Anthony Patricio
 */
public abstract class TestCaseWithData extends TestCase {

	protected void initData(){
		Team psg;
		Team om;
		Team rcl;
		Team bigTeam;
    
		Player barthez;
		Player utaka;
		Player fiorez;
	
		Game psgOm;
		Game omPsg;
		Game psgRcl;
		Game rclPsg;
		Game omRcl;
		Game rclOm;
	
		
		Coach vahid;
		Coach fernandez;
		Coach c3;
		// Prepare DAOS


		// Players
		barthez = new Player("Barthez");
		utaka = new Player("utaka");
		fiorez = new Player("fiorez");
		
		
		// Coachs
		vahid = new Coach("Vahid");
		fernandez = new Coach("Fernandez");
		c3 = new Coach("je lui cherche un nom");

		// Teams
		psg = new Team("psg");
		psg.setCoach(vahid);
		psg.addPlayer(fiorez);
		
		
		om = new Team("Olympique de Marseilles");
		om.setCoach(c3);
		om.addPlayer(barthez);
		rcl = new Team ("Racing Club de Lens");
		rcl.setCoach(fernandez);
		rcl.addPlayer(utaka);

		
		//games
		psgOm = new Game(psg,om,1,0,barthez);
		psgOm.setId(new Long(1));
		omPsg = new Game(om,psg,0,2,barthez);
		omPsg.setId(new Long(2));
		psgRcl = new Game(psg,rcl,3,0,utaka);
		psgRcl.setId(new Long(3));
		rclPsg = new Game(rcl,psg,1,2,fiorez);
		rclPsg.setId(new Long(4));
		omRcl = new Game(om,rcl,4,0,barthez);
		omRcl.setId(new Long(5));
		rclOm = new Game(rcl,om,1,0,utaka);
		rclOm.setId(new Long(6));
		try{
			Session session = openSession();
			Transaction tx = session.beginTransaction();
			session.save(psg);
			session.save(om);
			session.save(rcl);
			session.save(psgOm);
			session.save(omPsg);
			session.save(psgRcl);
			session.save(rclPsg);
			session.save(omRcl);
			session.save(rclOm);
			tx.commit();
			session.close();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}

	public TestCaseWithData(String x) {
		super(x);
	}
	
	public String[] getMappings() {
		return new String[] {"cours8/handwrittenSQL/model/Team.hbm.xml","cours8/handwrittenSQL/model/Coach.hbm.xml","cours8/handwrittenSQL/model/Player.hbm.xml","cours8/handwrittenSQL/model/Game.hbm.xml" };
	}
}
